%define fromkernel 2.6.18

Summary: Driver for reading and writing on XFS formatted volumes
Name: dkms-xfs
Version: %{fromkernel}
Release: 3%{?dist}
License: GPL
Group: System Environment/Kernel
URL: http://www.kernel.com/
# Created after extracting linux kernel sources and running:
# tar cjvf xfs-%{fromkernel}.tar.bz2 \
# Documentation/filesystems/xfs.txt COPYING fs/xfs/
Source: xfs-%{fromkernel}.tar.bz2
Patch0: xfs-2.6.18-dkms.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch: noarch
Requires: gcc, make
Requires(post): dkms
Requires(preun): dkms

%description
Driver (Linux kernel module) for reading and writing on XFS formatted volumes.


%prep
%setup -c
%patch0 -p1


%build


%install
%{__rm} -rf %{buildroot}

%define dkms_name xfs
%define dkms_vers %{version}-%{release}
%define quiet -q

# Kernel module sources install for dkms
%{__mkdir_p} %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{__cp} -a fs/xfs/* %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/

# Configuration for dkms
%{__cat} > %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/dkms.conf << 'EOF'
PACKAGE_NAME=%{dkms_name}
PACKAGE_VERSION=%{dkms_vers}
MAKE[0]="make -C ${kernel_source_dir} M=${dkms_tree}/%{dkms_name}/%{dkms_vers}/build CONFIG_XFS_FS=m CONFIG_XFS_EXPORT=y CONFIG_XFS_RT=y CONFIG_XFS_QUOTA=y CONFIG_XFS_DMAPI= CONFIG_XFS_SECURITY=y CONFIG_XFS_POSIX_ACL=y"
CLEAN[0]="make -C ${kernel_source_dir} M=${dkms_tree}/%{dkms_name}/%{dkms_vers}/build clean"
BUILT_MODULE_NAME[0]=xfs
DEST_MODULE_LOCATION[0]=/kernel/fs/xfs
AUTOINSTALL="YES"
EOF


%clean
%{__rm} -rf %{buildroot}


%post
# Add to DKMS registry
dkms add -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
# Rebuild and make available for the currenty running kernel
dkms build -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
dkms install -m %{dkms_name} -v %{dkms_vers} %{?quiet} --force || :

%preun
# Remove all versions from DKMS registry
dkms remove -m %{dkms_name} -v %{dkms_vers} %{?quiet} --all || :


%files
%defattr(-,root,root,-)
%doc COPYING Documentation/filesystems/xfs.txt
%{_usrsrc}/%{dkms_name}-%{dkms_vers}/


%changelog
* Mon Dec  3 2007 Matthias Saou <http://freshrpms.net/> 2.6.18-3
- Fix the module by including -DCONFIG_XFS_* defines through the patch.

* Wed Nov 28 2007 Matthias Saou <http://freshrpms.net/> 2.6.18-2
- Initial RPM release, based on the dkms-ntfs spec file.
- Use xfs code from RHEL kernel source rpm since RHEL removed i_blksize.
- Include patch to get includes right and find Makefile-linux-2.6.

